/**
 * Created by elamathi on 26/12/17.
 */


//load component specific options from Joomla Options storage
var EasyCheckoutOptions = Joomla.getOptions('com_easycheckout');

if (typeof(EasyCheckoutOptions.url.ajax_url) == 'undefined') {
    var ajax_url = 'index.php';
} else {
    var ajax_url = EasyCheckoutOptions.url.ajax_url;
}

if (typeof(EasyCheckoutOptions.url.loader) == 'undefined') {
    var ajax_loader = '';
} else {
    var ajax_loader = EasyCheckoutOptions.url.loader;
}


if (typeof(EasyCheckoutOptions.text.select_text) == 'undefined') {
    var select_text = '-- Select --';
} else {
    var select_text = EasyCheckoutOptions.text.select_text;
}

if (typeof(EasyCheckoutOptions.text.none_text) == 'undefined') {
    var none_text = 'None';
} else {
    var none_text = EasyCheckoutOptions.text.none_text;
}
 // Print in the browser console your options
function validate_checkout(type) {
    (function ($) {
        if (type == '') {
            type = 'validate';
        }
        var datas = {
            option : 'com_easycheckout',
            view: 'checkouts',
            task : 'validate_checkout',
            process_type : type
        };

        ///var billing_address = $('.easy-checkout-checkout-form input[name=billing_address]').val();
        //datas['billing_address'] = billing_address;

        // same as billing address
        var shipping_address = $('#same_as_billing_address:checked').length;
        datas['shipping_address'] = shipping_address;

        // billing address data
        var bill_address = $('#easy-checkout-billing-address input, #easy-checkout-billing-address select, #easy-checkout-billing-address textarea').serializeArray();
        datas['billing'] = bill_address;

        //shipping address data
        var ship_address = $('#easy-checkout-shipping-address input, #easy-checkout-shipping-address select, #easy-checkout-shipping-address textarea').serializeArray();
        datas['shipping'] = ship_address;

        // payment field data
        var payment_custom_field = $('#payment-j2store-custom-field input, #payment-j2store-custom-field select, #payment-j2store-custom-field textarea').serializeArray();
        datas['payment'] = payment_custom_field;

        // shipping method data
        var shipping_method = $('#shippingcost-pane input,#shippingcost-pane select,#shippingcost-pane textarea').serializeArray();
        datas['shipping_method'] = shipping_method;

        //payment element
        var payment_plugin = $('#onCheckoutPayment_wrapper .payment_plugin:checked').val();
        datas['payment_plugin'] = payment_plugin;

        // payment form data
        var payment_data = $('#payment_form_div input,#payment_form_div select,#payment_form_div textarea').serializeArray();
        datas['payment_form_data'] = payment_data;
        // customer note
        var customer_note = $('.customer-note textarea').val();
        datas['customer_note'] = customer_note;

        // terms and condition
        var checkbox_tos = $('#checkbox_tos input[name=tos_check]:checked').length;
        datas['checkbox_tos'] = checkbox_tos;

        //for logged in user

        // existing billing type
        var billing_address_type = $('#billing-blog input[name=billing_address_type]:checked').val();
        datas['billing_address_type'] = billing_address_type;

        // existing address id
        var existing_address_id = $('#billing-existing #existing_address_id').val();
        datas['address_id'] = existing_address_id;

        // new billing address
        var new_billing_address = $('#billing_new_address input, #billing_new_address select, #billing_new_address textarea').serializeArray();
        datas['new_billing_address'] = new_billing_address;

        // existing shipping type
        var shipping_address_type = $('#shipping-blog input[name=shipping_address_type]:checked').val();
        datas['shipping_address_type'] = shipping_address_type;

        var billing_blog = $('#billing-blog input,#billing-blog select,#billing-blog textarea').serializeArray();
        datas['billing_blog'] = billing_blog;

        var shipping_blog = $('#shipping-blog input,#shipping-blog select,#shipping-blog textarea').serializeArray();
        datas['shipping_blog'] = shipping_blog;

        var register_blog = $('.create-account input,.create-account select,.create-account textarea').serializeArray();
        datas['register_blog'] = register_blog;



        // existing shipping address id
        var existing_shipping_address_id = $('#shipping-existing #existing_shipping_address_id').val();
        datas['shipping_address_id'] = existing_shipping_address_id;

        // new shipping address
        var new_shipping_address = $('#shipping_new_address input, #shipping_new_address select, #shipping_new_address textarea').serializeArray();
        datas['new_shipping_address'] = new_shipping_address;

        var payment_shipping_app_plugin_input = $('#cart_refresh_block input, #cart_refresh_block select,#cart_refresh_block textarea').serialize();

        datas['payment_shipping_input'] = payment_shipping_app_plugin_input;


        $.ajax({
            url: ajax_url,
            type: 'post',
            dataType: 'json',
            data: datas,
            beforeSend: function() {
                $('.j2error').remove();
                $('#shipping_payment_error #payment_error').removeClass('alert alert-danger');
                $('#shipping_payment_error #shipping_error').removeClass('alert alert-danger');
                $('.checkout-validate-button').after('<span class="wait">&nbsp;<img src="'+ ajax_loader +'" alt="" /></span>');
            },
            complete: function() {
                $('.wait').remove();
            },
            success: function(json) {
                if(json['html']){
                    // replace with html
                    $('#cart_refresh_block').html(json['html']);
                }
                if(json['error']){
                    if(json['error']['billing']){
                        $.each(json['error']['billing'],function (key,value) {
                            $('#easy-checkout-billing-address #'+key).after('<span class="j2error">'+value+'</span>');
                        })
                    }

                    if(json['error']['shipping']){
                        $.each(json['error']['shipping'],function (key,value) {
                            $('#easy-checkout-shipping-address #shipping_'+key).after('<span class="j2error">'+value+'</span>');
                        })
                    }

                    if(json['error']['payment']){
                        $.each(json['error']['payment'],function (key,value) {
                            $('#payment-j2store-custom-field #payment_'+key).after('<span class="j2error">'+value+'</span>');
                        })
                    }

                    if(json['error']['new_billing_address']){
                        $.each(json['error']['new_billing_address'],function (key,value) {
                            $('#billing_new_address #'+key).after('<span class="j2error">'+value+'</span>');
                        })
                    }

                    if(json['error']['new_shipping_address']){
                        $.each(json['error']['new_shipping_address'],function (key,value) {
                            $('#shipping_new_address #shipping_'+key).after('<span class="j2error">'+value+'</span>');
                        })
                    }


                    if(json['error']['shipping_method']){
                        $('#shipping_payment_error #shipping_error').html('<span class="j2error">'+json['error']['shipping_method']+'</span>')
                        $('#shipping_payment_error #shipping_error').addClass('alert alert-danger');
                    }
                    if(json['error']['payment_method']){
                        $('#shipping_payment_error #payment_error').html('<span class="j2error">'+json['error']['payment_method']+'</span>')
                        $('#shipping_payment_error #payment_error').addClass('alert alert-danger');
                    }
                    if(json['error']['warning']){
                        $('.easy-checkout-error-container').html('<span class="j2error">'+json['error']['warning']+'</span>');
                    }

                    if(json['error']['tos_check']){
                        $('#checkbox_tos .j2error').html(json['error']['tos_check']);
                    }

                    $( 'body' ).trigger( 'after_validate_checkout', [json] );
                }

                if(payment_data){
                    $.each(payment_data,function (index,payment_details) {
                        $('#payment_form_div input[name='+payment_details.name+'], #payment_form_div select[name='+payment_details.name+'], #payment_form_div textarea[name='+payment_details.name+']').val(payment_details.value);
                    });
                }

                if(json['redirect']){
                    // do prepayment
                    window.location = json['redirect']
                }

                if(json['success']){
                    // replace with html
                }
            },
            error: function(xhr, ajaxOptions, thrownError) {
                //alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
            }
        });
    })(jQuery);
}
(function ($) {


    $(document).ready(function(){
        $( "#toggle_show_login_form" ).click(function() {
            $('#easy-returning-customer-login-form').toggle();
        });
    });
    // checkout register/guest change
    $(document).on('click','#easy-checkout-billing-address input[name=create_account]',function () {
        var create_account = $('#easy-checkout-billing-address input[name=create_account]:checked').length;
        console.log('hiii');
        if(create_account){
            $('#easy-checkout-billing-address #create-account-fields').show();
        }else {
            $('#easy-checkout-billing-address #create-account-fields').hide();
        }
        console.log(create_account);
    });
    //force utf
    $(document).ready(function () {
        $.ajaxSetup({
            'beforeSend': function (xhr) {
                xhr.overrideMimeType('text/html; charset=UTF-8');
            }
        });

        $('#billing-blog input[name=billing_address_type]:checked').trigger('click');
        $('#shipping-blog input[name=shipping_address_type]:checked').trigger('click');

    });

    //login action
    $(document).on('click', '#easy-checkout-button-login', function () {

        $.ajax
            ({
                url: ajax_url,
                type: 'post',
                cache: false,
                data: $('#easy-checkout-returning-customer input'),
                dataType: 'json',
                beforeSend: function () {
                    $('#button-login').attr('disabled', true);
                }
            })
            .always(function () {
                $('#button-login').attr('disabled', false);
                $('.wait').remove();

            })
            .done(function (json) {
                $('.warning, .j2error').remove();

                if (json['redirect']) {
                    //it is sufficient to just reload the page
                    window.location.href = json['redirect'];
                } else if (json['error']) {
                    $('.easy-checkout-error-container').append('<div class="warning alert alert-danger" style="display: none;">' + json['error']['warning'] + '<button data-dismiss="alert" class="close" type="button">×</button></div>');

                    $('.warning').fadeIn('slow');
                }
            })
            .fail(function (xhr, ajaxOptions, thrownError) {
                //alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
            });

    });

    $(document).on('change', 'select[name=\'country_id\']', function () {

        	if (this.value == '') return;
        $.ajax({
            url: ajax_url,
            data : 'option=com_j2store&view=carts&task=getCountry&country_id=' + this.value,
            dataType: 'json',
            beforeSend: function() {
                $('select[name=\'country_id\']').after('<span class="wait">&nbsp;<img src="'+ ajax_loader +'" alt="" /></span>');
            },
            complete: function() {
                $('.wait').remove();
            },
            success: function(json) {
                if (json['postcode_required'] == '1') {
                    $('#billing-postcode-required').show();
                } else {
                    $('#billing-postcode-required').hide();
                }

                html = '<option value="">'+ select_text +'</option>';

                if (json['zone'] != '') {
                    default_zone_id = $('#zone_id_default_value').val();

                    for (i = 0; i < json['zone'].length; i++) {
                        html += '<option value="' + json['zone'][i]['j2store_zone_id'] + '"';

                        if (json['zone'][i]['j2store_zone_id'] == default_zone_id) {
                            html += ' selected="selected"';
                        }

                        html += '>' + json['zone'][i]['zone_name'] + '</option>';
                    }
                } else {
                    html += '<option value="0" selected="selected">'+ none_text +'</option>';
                }

                $('select[name=\'zone_id\']').html(html);
                $('select[name=\'zone_id\']').trigger("chosen:updated");
                $('select[name=\'zone_id\']').trigger("liszt:updated");
                //liszt:updated
                validate_checkout('validate');
            },
            error: function(xhr, ajaxOptions, thrownError) {
                //alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
            }
        });
    });

    if($('select[name=\'country_id\']').length > 0) {
        $('select[name=\'country_id\']').trigger('change');

    }

    $(document).on('change', 'select[name=\'shipping_country_id\']', function () {

        if (this.value == '') return;
        $.ajax({
            url: ajax_url,
            data : 'option=com_j2store&view=carts&task=getCountry&country_id=' + this.value,
            dataType: 'json',
            beforeSend: function() {
                $('select[name=\'shipping_country_id\']').after('<span class="wait">&nbsp;<img src="'+ ajax_loader +'" alt="" /></span>');
            },
            complete: function() {
                $('.wait').remove();
            },
            success: function(json) {
                if (json['postcode_required'] == '1') {
                    $('#billing-postcode-required').show();
                } else {
                    $('#billing-postcode-required').hide();
                }

                html = '<option value="">'+ select_text +'</option>';

                if (json['zone'] != '') {
                    default_zone_id = $('#zone_id_default_value').val();

                    for (i = 0; i < json['zone'].length; i++) {
                        html += '<option value="' + json['zone'][i]['j2store_zone_id'] + '"';

                        if (json['zone'][i]['j2store_zone_id'] == default_zone_id) {
                            html += ' selected="selected"';
                        }

                        html += '>' + json['zone'][i]['zone_name'] + '</option>';
                    }
                } else {
                    html += '<option value="0" selected="selected">'+ none_text +'</option>';
                }

                $('select[name=\'shipping_zone_id\']').html(html);
                $('select[name=\'shipping_zone_id\']').trigger("chosen:updated");
                $('select[name=\'shipping_zone_id\']').trigger("liszt:updated");
                //liszt:updated
                validate_checkout('validate');
            },
            error: function(xhr, ajaxOptions, thrownError) {
                //alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
            }
        });
    });

    if($('select[name=\'shipping_country_id\']').length > 0) {
        $('select[name=\'shipping_country_id\']').trigger('change');

    }





    $(document).on('change','#easy-checkout-billing-address #zip, #easy-checkout-billing-address #zone_id, #easy-checkout-shipping-address #shipping_zip, #easy-checkout-shipping-address #shipping_zone_id',function () {
        validate_checkout('validate');
    });

    $(document).on('click','.checkout-validate-button',function () {
        validate_checkout('submit');
    });

    $(document).on('change','#billing-existing #existing_address_id',function () {
        var billing_address_type = $('#billing-address-existing:checked').val();
        if(billing_address_type == 'existing'){
            validate_checkout('validate');
        }
    });

    $(document).on('click','#same_as_billing_address',function () {
       if($('#same_as_billing_address:checked').length == 1){
            $('#easy-checkout-shipping-address').hide();
       }

        if($('#same_as_billing_address:checked').length == 0){
            $('#easy-checkout-shipping-address').show();
        }

    });

    $(document).on('click','#billing-blog input[name=billing_address_type]',function () {
        if($('#billing-blog input[name=billing_address_type]:checked').val() == 'existing'){
            $('#billing-blog #billing-existing').show();
            $('#billing-blog #billing_new_address').hide();
        }

        if($('#billing-blog input[name=billing_address_type]:checked').val() == 'new'){
            $('#billing-blog #billing-existing').hide();
            $('#billing-blog #billing_new_address').show();
        }
    });

    $(document).on('click','#shipping-blog input[name=shipping_address_type]',function () {
        if($('#shipping-blog input[name=shipping_address_type]:checked').val() == 'existing'){
            $('#shipping-blog #shipping-existing').show();
            $('#shipping-blog #shipping_new_address').hide();
        }

        if($('#shipping-blog input[name=shipping_address_type]:checked').val() == 'new'){
            $('#shipping-blog #shipping-existing').hide();
            $('#shipping-blog #shipping_new_address').show();
        }
    });

    $(document).on('click','#shipping_zip',function () {
        validate_checkout('validate');
    });

})(jQuery);

function saveAddress(address,type) {
    (function ($) {
        console.log(type);
        var data = {
          option: 'com_easycheckout',
          view: 'checkouts',
          task: 'saveAddress',
          address_type: type
        };
        console.log(data);
        data['address_data'] = $('#'+address+' input, #'+address+' select, #'+address+' textarea').serializeArray();
        $.ajax({
            url: ajax_url,
            dataType: 'json',
            data: data,
            beforeSend: function() {
                $('.j2error').remove();
                $('#'+address+'_btn').after('<span class="wait">&nbsp;<img src="'+ ajax_loader +'" alt="" /></span>');
            },
            complete: function() {
                $('.wait').remove();
            },
            success: function(json) {

                if(json['error']){
                    if(json['error']['billing']){
                        $.each(json['error']['billing'],function (key,value) {
                            $('#'+address+' #'+key).after('<span class="j2error"><br>'+value+'</span>');
                        })
                    }

                    if(json['error']['shipping']){
                        $.each(json['error']['shipping'],function (key,value) {
                            $('#'+address+' #shipping_'+key).after('<span class="j2error"><br>'+value+'</span>');
                        })
                    }
                }

                if(json['redirect']){
                    // do prepayment
                    window.location = json['redirect']
                }
            },
            error: function(xhr, ajaxOptions, thrownError) {
                //alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
            }
        });


    })(jQuery);
}

function j2storeSetShippingRateOne(name, price, tax, extra, code, combined, ship_element, css_id, call_type )
{
    (function ($) {
        $("input[type='hidden'][name='shipping_name']").val(name);
        $("input[type='hidden'][name='shipping_code']").val(code);
        $("input[type='hidden'][name='shipping_price']").val(price);
        $("input[type='hidden'][name='shipping_tax']").val(tax);
        $("input[type='hidden'][name='shipping_extra']").val(extra);
        var ship_name = name.replace(' ','');
        $('#onCheckoutShipping_wrapper .shipping_element').hide();
        $('#onCheckoutShipping_wrapper .'+css_id+'_select_text').show();
        if(call_type == 'click'){
            validate_checkout('validate');
        }
    })(jQuery);
}

function EasyCheckoutPaymentForm(url,container,form, msg, formdata) {
    (function ($) {
        //to make div compatible
        container = '#'+container;
        console.log(formdata);
        $.ajax({
            url : 'index.php',
            type: 'get',
            data: formdata,
            dataType: 'json',
            beforeSend: function() {
                $(container).before('<span class="wait"><img src="'+j2storeURL+'media/j2store/images/loader.gif" alt="" /></span>');
            },
            complete: function() {
                $('.wait').remove();
            },
            success: function(json) {
                if ($(container).length > 0) {
                    $(container).html(json.msg);
                }
            }
        });
    })(jQuery);
}

